#define ENTRY(name)				\
	.align 32;				\
	.proc name;				\
name:

#define GLOBAL_ENTRY(name)			\
	.global name;				\
	ENTRY(name)

#define END(name)				\
	.endp name

GLOBAL_ENTRY(flush_icache_range)
	.prologue
	alloc r2=ar.pfs,2,0,0,0
	sub r8=in1,in0,1
	;;
	shr.u r8=r8,5			// we flush 32 bytes per iteration
	.save ar.lc, r3
	mov r3=ar.lc			// save ar.lc
	;;

	.body

	mov ar.lc=r8
	;;
.Loop:	fc in0				// issuable on M0 only
	add in0=32,in0
	br.cloop.sptk.few .Loop
	;;
	sync.i
	;;
	srlz.i
	;;
	mov ar.lc=r3			// restore ar.lc
	br.ret.sptk.many rp
END(flush_icache_range)
