PHDRS {
  reginfo	0x70000000; /* PT_MIPS_REGINFO */
  core		PT_LOAD;
  mod		0x60000001;
  init		PT_LOAD;
  dyn		PT_DYNAMIC;
}

SECTIONS
{
  .reginfo : { *(.reginfo) } :reginfo :core

  .text : { *(.text) } :core
  .gnu.linkonce.this_module : { *(.gnu.linkonce.this_module) } :core :mod
  .rodata : { *(.rodata) *(.rodata.*) } :core

  /* Generated module information */
  __ex_table : { 
	__start___ex_table = .;
	*(__ex_table)
	__stop___ex_table = .;
  } :core

  __ksymtab : {
	__start___ksymtab = .;
	*(__ksymtab)
	__stop___ksymtab = .;
  } :core

  .data : { *(.data) CONSTRUCTORS } :core
  .plt : { *(.plt) } :core
  .got : { *(.got.plt) *(.got*) } :core
  .sdata : { *(.sdata) *(.sdata2) } :core
  .sbss : { *(.sbss) *(.dynsbss) *(.scommon) } :core
  .bss : { *(.bss) *(.dynbss) *(COMMON) } :core

  /* FIXME: Core or init? */
  .stub : { *(.stub) } :core

  .init.text ALIGN(4096) : {
	__module_cut = .; /* From here down can be discarded. */
	*(.init.text)
  } :init
  .init.data : {
	*(.init.data) *(.init.setup) *(.init.param) *(.param.init)
  } :init

  __param : {
	__start___param = .;
	*(__param)
	__stop___param = .;
  } :init

  __obsparm : {
	__start___obsparm = .;
	*(__obsparm)
	__stop___obsparm = .;
  } :init

  .rel.dyn : { *(.rel.dyn) } :init

  .dynamic : { *(.dynamic) }  :init :dyn

  .hash : { *(.hash) } :init :dyn
  .dynsym : { *(.dynsym) } :init :dyn
  .dynstr : { *(.dynstr) } :init :dyn
}
