/* Anton's hope-fully-correct icache flush */
#define XGLUE(a,b) a##b
#define GLUE(a,b) XGLUE(a,b)
#define _GLOBAL(name) \
	.section ".text"; \
	.align 2 ; \
	.globl name; \
	.globl GLUE(.,name); \
	.section ".opd","aw"; \
name: \
	.quad GLUE(.,name); \
	.quad .TOC.@tocbase; \
	.quad 0; \
	.previous; \
	.type GLUE(.,name),@function; \
GLUE(.,name):

	.text
	.align 5

/* Thanks to Paul M */\
_GLOBAL(region_cache_flush)
	add	5,3,4		/* ending address */
	addi	5,5,127		/* round up */
	clrrdi	3,3,7		/* round down to cache line boundary */
	subf	4,3,5
	srdi	4,4,7
	mtctr	4
	mr	6,3
0:	dcbst	0,3			/* Write line to ram */
	addi	3,3,128
	bdnz	0b
	sync
	mtctr	4
1:	icbi	0,6
	addi	6,6,128
	bdnz	1b
	sync
	isync
	blr
